<script setup>
import AuthenticatedLayout from "@/Layouts/AuthenticatedLayout.vue";
import Tags from '@/Components/Tags.vue';
import { Head } from "@inertiajs/vue3";
import axios from "axios";
import { ref, onBeforeMount } from "vue";

const props = defineProps({
    resources: {
        type: Array,
    },
    tags: {
      type: Array
    }
});
const resources = ref([]);
const tags = ref([]);
const filter = ref([]);
const new_resource = ref({
  title: "",
});
const edit_resource = ref({
  title: "",
});
const errors = ref({});
const error_message = ref("");

onBeforeMount(() => {
  resources.value = props.resources;
  setFilter();
})

function setFilter() {
  tags.value = props.tags;
  tags.value.forEach((tag) => {
    filter.value.push({
      title: tag.title, 
      checked : true
    });
  });
}

function open(id) {
  let element = document.getElementById(id);
  element.style.display = "block";
}

function close(id) {
  let element = document.getElementById(id);
  element.style.display = "none";
}

function store() {
    errors.value = {};
    axios.post('/resources', new_resource.value).then((response) => {
        if (response.status == 200) {
            resources.value.push(response.data);
            close('createModal');
        } else {
            console.warn(response.data);
        }
    }).catch((error) => {
        console.log(error);
        if (error.response.status == 422) {
            errors.value = error.response.data.errors;
        } else {
            console.error(error.response.statusText);
        }
    });
}

    function update (id) {
      errors.value = {};
      axios.put('/resources/' + id,  edit_resource.value).then((response) => {
        if (response.status == 200) {
          let res = response.data;
          resources.value.forEach((resource, index, array) => {
            if (resource.id == id) {
              Object.assign(resource, res);
            }
          });
          close('editModal' + id);
        } else {
          console.warn(response.data);
        }
      }).catch((error) => {
        if (error.response.status == 422) {
          errors.value = error.response.data.errors;
        } else {
          console.error(error.response.statusText);
        }
      });
    }

    function destroy (id) {
      errors.value = {};
      axios.delete('/resources/' + id).then((response) => {
        if (response.status == 200) {
          resources.value = resources.value.filter((resource) => {
            return resource.id != id;
          });
          close('deleteModal' + id);
        } else {
          console.warn(response.data);
        }
      }).catch((error) => {
        console.error(error.response.statusText);
      });
    }

    function edit (id) {
      resources.value.forEach((resource) => {
        if (resource.id == id) {
          edit_resource.value = {
            title: resource.title
          };
        }
      });
      open('editModal' + id);
    }

    function filterResources() {
      let filteredTitles = [];
      filter.value.forEach((item) => {
        if (item.checked) {
          filteredTitles.push(item.title);
        }
      });
      
      resources.value = props.resources;
      resources.value = resources.value.filter((resource) => {
        let resourceTags = [];
        resource.tags.forEach((item) => {
          resourceTags.push(item.title);
        });
        return resourceTags.some(resourceTag => {
          return filteredTitles.includes(resourceTag);
        });
      });
    }
</script>

<template>
  <Head title="Resources" />

  <AuthenticatedLayout>
    <template #header>
      <h2
        class="font-semibold text-xl text-gray-800 dark:text-gray-200 leading-tight"
      >
        Resources
      </h2>
    </template>

    <div class="py-12">
      <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div
          class="bg-white dark:bg-gray-800 overflow-hidden shadow-sm sm:rounded-lg"
        >
          <div class="p-6 text-gray-900 dark:text-gray-100">
            <div>
              <!-- create -->
              <div class="flex justify-between gap-3">
                <div class="flex gap-2">
                  <div class="relative flex gap-x-3" v-for="(tag, index) in filter" :key="index">
                    <div class="flex h-6 items-center">
                      <input :id="'tag'+index" v-model="tag.checked" @change="filterResources" type="checkbox" class="h-4 w-4 rounded border-gray-300 text-indigo-600 focus:ring-indigo-600">
                    </div>
                    <div class="text-sm leading-6">
                      <label :for="'tag'+index" class="font-medium text-gray-900">{{ tag.title }}</label>
                    </div>
                  </div>
                </div>
                <div>
                  <button
                    class="px-3 py-1 bg-green-600 text-white rounded shadow mb-3"
                    @click="open('createModal')"
                  >
                    Create
                  </button>
                </div>
              </div>
              <!-- This example requires Tailwind CSS v2.0+ -->
              <div
                id="createModal"
                class="fixed z-10 inset-0 overflow-y-auto"
                aria-labelledby="modal-title"
                role="dialog"
                aria-modal="true"
                style="display: none"
              >
                <div
                  class="flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0"
                >
                  <!--
                Background overlay, show/hide based on modal state.

                Entering: "ease-out duration-300"
                  From: "opacity-0"
                  To: "opacity-100"
                Leaving: "ease-in duration-200"
                  From: "opacity-100"
                  To: "opacity-0"
              -->
                  <div
                    class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity"
                    aria-hidden="true"
                  ></div>

                  <!-- This element is to trick the browser into centering the modal contents. -->
                  <span
                    class="hidden sm:inline-block sm:align-middle sm:h-screen"
                    aria-hidden="true"
                    >&#8203;</span
                  >

                  <!--
                Modal panel, show/hide based on modal state.

                Entering: "ease-out duration-300"
                  From: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95"
                  To: "opacity-100 translate-y-0 sm:scale-100"
                Leaving: "ease-in duration-200"
                  From: "opacity-100 translate-y-0 sm:scale-100"
                  To: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95"
              -->
                  <div
                    class="inline-block align-bottom bg-white rounded-lg text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full"
                  >
                    <div class="bg-gray-50 px-4 py-3 sm:px-6">
                      <h3
                        class="text-lg leading-6 font-medium text-gray-900 mb-3"
                      >
                        Add resource
                      </h3>
                    </div>
                    <div class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4">
                      <div>
                        <div class="w-full">
                          <div class="mb-4">
                            <label
                              class="block text-gray-700 text-sm font-bold mb-2"
                              for="title"
                            >
                              Title
                            </label>
                            <input
                              v-model="new_resource.title"
                              class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
                              id="title"
                              type="text"
                              placeholder="Title"
                            />
                            <p
                              class="text-red-500 text-xs italic"
                              v-if="errors['title']"
                            >
                              {{ errors["title"][0] }}
                            </p>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div
                      class="bg-gray-50 px-4 py-3 sm:px-6 sm:flex sm:flex-row-reverse"
                    >
                      <button
                        @click="store"
                        type="button"
                        class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-green-600 text-base font-medium text-white hover:bg-green-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-green-500 sm:ml-3 sm:w-auto sm:text-sm"
                      >
                        Create
                      </button>
                      <button
                        @click="close('createModal')"
                        type="button"
                        class="mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:ml-3 sm:w-auto sm:text-sm"
                      >
                        Cancel
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- table -->
            <div
              class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
            >
              <table class="min-w-full divide-y divide-gray-200">
                <thead class="bg-gray-50">
                  <tr>
                    <th
                      scope="col"
                      class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                    >
                      ID
                    </th>
                    <th
                      scope="col"
                      class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                    >
                      Title
                    </th>
                    <th
                      scope="col"
                      class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                    >
                      Tags
                    </th>
                    <th
                      scope="col"
                      class="px-6 py-3 text-right text-xs font-medium text-gray-500 uppercase tracking-wider"
                    >
                      Actions
                    </th>
                  </tr>
                </thead>
                <tbody class="bg-white divide-y divide-gray-200">
                  <tr v-for="(resource, index) in resources" :key="index">
                    <td class="px-6 py-4 whitespace-nowrap">
                      <div class="flex items-center">
                        {{ resource.id }}
                      </div>
                    </td>
                    <td class="px-6 py-4 whitespace-nowrap">
                      <div class="text-sm text-gray-900">
                        {{ resource.title }}
                      </div>
                    </td>
                    <td class="px-6 py-4 whitespace-nowrap">
                      <div class="text-sm text-gray-900">
                        <Tags :resource="resource" :key="resource.id"></Tags>
                      </div>
                    </td>
                    <td
                      class="px-6 py-4 whitespace-nowrap text-right text-sm font-medium"
                    >
                      <div>
                        <button
                          class="px-3 py-1 bg-blue-600 text-white rounded shadow mb-3 mx-1"
                          @click="edit(resource.id)"
                        >
                          Edit
                        </button>
                        <button
                          class="px-3 py-1 bg-red-600 text-white rounded shadow mb-3 mx-1"
                          @click="open('deleteModal'+ resource.id)"
                        >
                          Delete
                        </button>
                        <div class="whitespace-normal">
                          <!-- This example requires Tailwind CSS v2.0+ -->
                          <div
                            :id="'editModal' + resource.id"
                            class="fixed z-10 inset-0 overflow-y-auto"
                            aria-labelledby="modal-title"
                            role="dialog"
                            aria-modal="true"
                            style="display: none"
                          >
                            <div
                              class="flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0"
                            >
                              <!--
                          Background overlay, show/hide based on modal state.

                          Entering: "ease-out duration-300"
                            From: "opacity-0"
                            To: "opacity-100"
                          Leaving: "ease-in duration-200"
                            From: "opacity-100"
                            To: "opacity-0"
                        -->
                              <div
                                class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity"
                                aria-hidden="true"
                              ></div>

                              <!-- This element is to trick the browser into centering the modal contents. -->
                              <span
                                class="hidden sm:inline-block sm:align-middle sm:h-screen"
                                aria-hidden="true"
                                >&#8203;</span
                              >

                              <!--
                          Modal panel, show/hide based on modal state.

                          Entering: "ease-out duration-300"
                            From: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95"
                            To: "opacity-100 translate-y-0 sm:scale-100"
                          Leaving: "ease-in duration-200"
                            From: "opacity-100 translate-y-0 sm:scale-100"
                            To: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95"
                        -->
                              <div
                                class="inline-block align-bottom bg-white rounded-lg text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full"
                              >
                                <div class="bg-gray-50 px-4 py-3 sm:px-6">
                                  <h3
                                    class="text-lg leading-6 font-medium text-gray-900 mb-3"
                                  >
                                    Update Resource
                                  </h3>
                                </div>
                                <div
                                  class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4"
                                >
                                  <div>
                                    <div class="w-full">
                                      <div class="mb-4">
                                        <label
                                          class="block text-gray-700 text-sm font-bold mb-2"
                                          :for="'edit_title' + resource.id"
                                        >
                                          Title
                                        </label>
                                        <input
                                          v-model="edit_resource.title"
                                          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
                                          :id="'edit_title' + resource.id"
                                          type="text"
                                          placeholder="Title"
                                        />
                                        <p
                                          class="text-red-500 text-xs italic"
                                          v-if="errors['title']"
                                        >
                                          {{ errors["title"][0] }}
                                        </p>
                                      </div>
                                    </div>
                                  </div>
                                </div>
                                <div
                                  class="bg-gray-50 px-4 py-3 sm:px-6 sm:flex sm:flex-row-reverse"
                                >
                                  <button
                                    @click="update(resource.id)"
                                    type="button"
                                    class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-blue-600 text-base font-medium text-white hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500 sm:ml-3 sm:w-auto sm:text-sm"
                                  >
                                    Update
                                  </button>
                                  <button
                                    @click="close('editModal' + resource.id)"
                                    type="button"
                                    class="mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:ml-3 sm:w-auto sm:text-sm"
                                  >
                                    Cancel
                                  </button>
                                </div>
                              </div>
                            </div>
                          </div>

                          <!-- This example requires Tailwind CSS v2.0+ -->
                          <div
                            :id="'deleteModal' + resource.id"
                            class="fixed z-10 inset-0 overflow-y-auto"
                            aria-labelledby="modal-title"
                            role="dialog"
                            aria-modal="true"
                            style="display: none"
                          >
                            <div
                              class="flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0"
                            >
                              <!--
                          Background overlay, show/hide based on modal state.

                          Entering: "ease-out duration-300"
                            From: "opacity-0"
                            To: "opacity-100"
                          Leaving: "ease-in duration-200"
                            From: "opacity-100"
                            To: "opacity-0"
                        -->
                              <div
                                class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity"
                                aria-hidden="true"
                              ></div>

                              <!-- This element is to trick the browser into centering the modal contents. -->
                              <span
                                class="hidden sm:inline-block sm:align-middle sm:h-screen"
                                aria-hidden="true"
                                >&#8203;</span
                              >

                              <!--
                          Modal panel, show/hide based on modal state.

                          Entering: "ease-out duration-300"
                            From: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95"
                            To: "opacity-100 translate-y-0 sm:scale-100"
                          Leaving: "ease-in duration-200"
                            From: "opacity-100 translate-y-0 sm:scale-100"
                            To: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95"
                        -->
                              <div
                                class="inline-block align-bottom bg-white rounded-lg text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full"
                              >
                                <div class="bg-gray-50 px-4 py-3 sm:px-6">
                                  <h3
                                    class="text-lg leading-6 font-medium text-gray-900 mb-3"
                                  >
                                    Delete Resource
                                  </h3>
                                </div>
                                <div
                                  class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4"
                                >
                                  <div>
                                    <div class="w-full">
                                      Are you sure you want to delete this?
                                    </div>
                                  </div>
                                </div>
                                <div
                                  class="bg-gray-50 px-4 py-3 sm:px-6 sm:flex sm:flex-row-reverse"
                                >
                                  <button
                                    @click="destroy(resource.id)"
                                    type="button"
                                    class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-red-600 text-base font-medium text-white hover:bg-red-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-red-500 sm:ml-3 sm:w-auto sm:text-sm"
                                  >
                                    Delete
                                  </button>
                                  <button
                                    @click="close('deleteModal' + resource.id)"
                                    type="button"
                                    class="mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:ml-3 sm:w-auto sm:text-sm"
                                  >
                                    Cancel
                                  </button>
                                </div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
  </AuthenticatedLayout>
</template>